Index: trunk/source/Lib/TLibRenderer/TRenInterpFilter.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenInterpFilter.h	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenInterpFilter.h	(revision 608)
@@ -520,459 +538,4 @@
   Int iSrcStride6 = iSrcStride*6;
   Int iSrcStride7 = iSrcStride*7;
-  Int shiftNum = g_uiBitIncrement + g_uiBitDepth - 8;
-  Int shiftOffset = (shiftNum > 0) ? ( 1 << (shiftNum - 1)) : 0 ;
-  Int  iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStride ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[          0]+piSrcTmp[iSrcStride7];
-      iTmp1 = piSrcTmp[iSrcStride ]+piSrcTmp[iSrcStride6];
-      iTmp2 = piSrcTmp[iSrcStride2]+piSrcTmp[iSrcStride5];
-      iTmp3 = piSrcTmp[iSrcStride3]+piSrcTmp[iSrcStride4];
-      
-      iTmpA = (iTmp3 << 2) - iTmp2;
-      
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;        
-      
-#if REMOVE_INTERMEDIATE_CLIPPING
-      piDst   [x * iDstStep] = (iSum +  shiftOffset) >>  shiftNum;
-#else
-      piDst   [x * iDstStep] = Clip3(0, 16383, (iSum +  shiftOffset) >>  shiftNum );
-#endif
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-
-}
-
-
-#endif
-
-// ------------------------------------------------------------------------------------------------
-// DCTIF filters
-// ------------------------------------------------------------------------------------------------
-
-__inline Void TRenInterpFilter::xCTI_FilterHalfHor(Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[        0]+piSrcTmp[iSrcStep7];
-      iTmp1 = piSrcTmp[iSrcStep]+piSrcTmp[iSrcStep6];
-      iTmp2 = piSrcTmp[iSrcStep2]+piSrcTmp[iSrcStep5];
-      iTmp3 = piSrcTmp[iSrcStep3]+piSrcTmp[iSrcStep4];
-
-      iTmpA = (iTmp3 << 2) - iTmp2;
-
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;
-
-      piDst   [x * iDstStep] = Clip( (iSum +  32) >>  6 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterHalfHor(Int* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Int*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[        0]+piSrcTmp[iSrcStep7];
-      iTmp1 = piSrcTmp[iSrcStep ]+piSrcTmp[iSrcStep6];
-      iTmp2 = piSrcTmp[iSrcStep2]+piSrcTmp[iSrcStep5];
-      iTmp3 = piSrcTmp[iSrcStep3]+piSrcTmp[iSrcStep4];
-      
-      iTmpA = (iTmp3 << 2) - iTmp2;
-      
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;
-      
-      piDst   [x * iDstStep] = Clip( (iSum +  2048) >>  12 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter0Hor(Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int  iTmp1, iTmp2;
-
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // {-1,   4,  -10,  57,   19,  -7,   3,   -1  },
-      
-      iTmp1 = piSrcTmp[iSrcStep3] + piSrcTmp[iSrcStep5];
-      iTmp2 = piSrcTmp[iSrcStep6] + piSrcTmp[iSrcStep4];
-      
-      iSum  =  iTmp1 + iTmp2 - piSrcTmp[0] - piSrcTmp[iSrcStep7]
-             - ( ( piSrcTmp[iSrcStep2] - iTmp2 ) << 1 )
-             + (  piSrcTmp[iSrcStep]             << 2 )
-             - ( ( piSrcTmp[iSrcStep2] + iTmp1 ) << 3 )
-             + (   piSrcTmp[iSrcStep4]           << 4 );
-      
-      piDst   [x * iDstStep] = Clip(( (iSum +  32) >>  6 )+ piSrcTmp[iSrcStep3]);
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter0Hor(Int* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Int*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int  iTmp1, iTmp2;
-
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // {-1,   4,  -10,  57,   19,  -7,   3,   -1  },
-    
-      iTmp1 = piSrcTmp[iSrcStep3] + piSrcTmp[iSrcStep5];
-      iTmp2 = piSrcTmp[iSrcStep6] + piSrcTmp[iSrcStep4];
-      
-      iSum  =  iTmp1 + iTmp2 - piSrcTmp[0] - piSrcTmp[iSrcStep7]
-            - ( ( piSrcTmp[iSrcStep2] - iTmp2 ) << 1 )
-            + (  piSrcTmp[iSrcStep]             << 2 )
-            - ( ( piSrcTmp[iSrcStep2] + iTmp1 ) << 3 )
-            + (   piSrcTmp[iSrcStep4]           << 4 )
-            + (   piSrcTmp[iSrcStep3]           << 6 );
-      
-      piDst   [x * iDstStep] = Clip( (iSum +  2048) >>  12 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter1Hor(Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int  iTmp1, iTmp2;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // {-1,   3,  -7,  19,   57,  -10,   4,   -1  },
-      
-      iTmp1 = piSrcTmp[iSrcStep4] + piSrcTmp[iSrcStep2];
-      iTmp2 = piSrcTmp[iSrcStep ] + piSrcTmp[iSrcStep3];
-      
-      iSum  =  iTmp1 + iTmp2 - piSrcTmp[0] - piSrcTmp[iSrcStep7]
-            - ( ( piSrcTmp[iSrcStep5] - iTmp2 ) << 1 )
-            + (   piSrcTmp[iSrcStep6]           << 2 )
-            - ( ( piSrcTmp[iSrcStep5] + iTmp1 ) << 3 )
-            + (   piSrcTmp[iSrcStep3]           << 4 );
-      
-      piDst   [x * iDstStep] = Clip( ((iSum +  32) >>  6) + piSrcTmp[iSrcStep4] );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter1Hor(Int* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst    = rpiDst;
-  Int   iSum;
-  Int*  piSrcTmp;
-  Int iSrcStep2 = iSrcStep*2;
-  Int iSrcStep3 = iSrcStep*3;
-  Int iSrcStep4 = iSrcStep*4;
-  Int iSrcStep5 = iSrcStep*5;
-  Int iSrcStep6 = iSrcStep*6;
-  Int iSrcStep7 = iSrcStep*7;
-
-  Int  iTmp1, iTmp2;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStep ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // {-1,   3,  -7,  19,   57,  -10,   4,   -1  },
-      
-      iTmp1 = piSrcTmp[iSrcStep4] + piSrcTmp[iSrcStep2];
-      iTmp2 = piSrcTmp[iSrcStep ] + piSrcTmp[iSrcStep3];
-      
-      iSum  =  iTmp1 + iTmp2 - piSrcTmp[0] - piSrcTmp[iSrcStep7]
-            - ( ( piSrcTmp[iSrcStep5] - iTmp2 ) << 1 )
-            + (   piSrcTmp[iSrcStep6]           << 2 )
-            - ( ( piSrcTmp[iSrcStep5] + iTmp1 ) << 3 )
-            + (   piSrcTmp[iSrcStep3]           << 4 )
-            + (   piSrcTmp[iSrcStep4]           << 6 );
-      
-      piDst   [x * iDstStep] = Clip( (iSum +  2048) >>  12 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterHalfVer (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Int*& rpiDst, Int iDstStridePel, Pel*& rpiDstPel )
-{
-  Int*  piDst = rpiDst;
-  Pel*  piDstPel = rpiDstPel;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStride2 = iSrcStride*2;
-  Int iSrcStride3 = iSrcStride*3;
-  Int iSrcStride4 = iSrcStride*4;
-  Int iSrcStride5 = iSrcStride*5;
-  Int iSrcStride6 = iSrcStride*6;
-  Int iSrcStride7 = iSrcStride*7;
-
-  Int  iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStride ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[          0]+piSrcTmp[iSrcStride7];
-      iTmp1 = piSrcTmp[iSrcStride ]+piSrcTmp[iSrcStride6];
-      iTmp2 = piSrcTmp[iSrcStride2]+piSrcTmp[iSrcStride5];
-      iTmp3 = piSrcTmp[iSrcStride3]+piSrcTmp[iSrcStride4];
-      
-      iTmpA = (iTmp3 << 2) - iTmp2;
-      
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;
-      
-      piDst[x * iDstStep]    = iSum;
-      piDstPel[x * iDstStep] = Clip( (iSum +  32) >>  6 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-    piDstPel += iDstStridePel;
-  }
- return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterHalfVer (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Int*& rpiDst)
-{
-  Int*  piDst = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStride2 = iSrcStride*2;
-  Int iSrcStride3 = iSrcStride*3;
-  Int iSrcStride4 = iSrcStride*4;
-  Int iSrcStride5 = iSrcStride*5;
-  Int iSrcStride6 = iSrcStride*6;
-  Int iSrcStride7 = iSrcStride*7;
-
-  Int  iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStride ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[          0]+piSrcTmp[iSrcStride7];
-      iTmp1 = piSrcTmp[iSrcStride ]+piSrcTmp[iSrcStride6];
-      iTmp2 = piSrcTmp[iSrcStride2]+piSrcTmp[iSrcStride5];
-      iTmp3 = piSrcTmp[iSrcStride3]+piSrcTmp[iSrcStride4];
-      
-      iTmpA = (iTmp3 << 2) - iTmp2;
-      
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;        
-      
-      piDst[x * iDstStep] = iSum;
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterHalfVer (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  
-  Int iSrcStride2 = iSrcStride*2;
-  Int iSrcStride3 = iSrcStride*3;
-  Int iSrcStride4 = iSrcStride*4;
-  Int iSrcStride5 = iSrcStride*5;
-  Int iSrcStride6 = iSrcStride*6;
-  Int iSrcStride7 = iSrcStride*7;
-
-  Int  iTmp0, iTmp1, iTmp2, iTmp3, iTmpA;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStride ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // { -1,4,-11,40,40,-11,4,-1   } 
-      iTmp0 = piSrcTmp[          0]+piSrcTmp[iSrcStride7];
-      iTmp1 = piSrcTmp[iSrcStride ]+piSrcTmp[iSrcStride6];
-      iTmp2 = piSrcTmp[iSrcStride2]+piSrcTmp[iSrcStride5];
-      iTmp3 = piSrcTmp[iSrcStride3]+piSrcTmp[iSrcStride4];
-      
-      iTmpA = (iTmp3 << 2) - iTmp2;
-      
-      iSum  = (   iTmp1          << 2 )
-            + (   iTmpA          << 3 )
-            + (   iTmpA          << 1 )
-            -    iTmp0 -  iTmp2;        
-      
-      piDst[x * iDstStep] = Clip( (iSum +  32) >>  6 );
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter0Ver (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Int*& rpiDst)
-{
-  Int*  piDst = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  Int iSrcStride2 = iSrcStride*2;
-  Int iSrcStride3 = iSrcStride*3;
-  Int iSrcStride4 = iSrcStride*4;
-  Int iSrcStride5 = iSrcStride*5;
-  Int iSrcStride6 = iSrcStride*6;
-  Int iSrcStride7 = iSrcStride*7;
-
-  Int  iTmp1, iTmp2;
-  for ( Int y = iHeight; y != 0; y-- )
-  {
-    piSrcTmp = &piSrc[ -3*iSrcStride ];
-    for ( Int x = 0; x < iWidth; x++ )
-    {
-      // {-1,   4,  -10,  57,   19,  -7,   3,   -1  },
-      
-      iTmp1 = piSrcTmp[iSrcStride3] + piSrcTmp[iSrcStride5];
-      iTmp2 = piSrcTmp[iSrcStride6] + piSrcTmp[iSrcStride4];
-      
-      iSum  =  iTmp1 + iTmp2 - piSrcTmp[0] - piSrcTmp[iSrcStride7]
-            - ( ( piSrcTmp[iSrcStride2] - iTmp2 ) << 1 )
-            + (  piSrcTmp[iSrcStride]             << 2 )
-            - ( ( piSrcTmp[iSrcStride2] + iTmp1 ) << 3 )
-            + (   piSrcTmp[iSrcStride4]           << 4 )
-            + (   piSrcTmp[iSrcStride3]           << 6 );
-      
-      piDst[x * iDstStep] = iSum;
-      piSrcTmp += iSrcStep;
-    }
-    piSrc += iSrcStride;
-    piDst += iDstStride;
-  }
-  return;
-}
-
-__inline Void TRenInterpFilter::xCTI_FilterQuarter0Ver (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
-{
-  Pel*  piDst = rpiDst;
-  Int   iSum;
-  Pel*  piSrcTmp;
-  
-  Int iSrcStride2 = iSrcStride*2;
-  Int iSrcStride3 = iSrcStride*3;
-  Int iSrcStride4 = iSrcStride*4;
-  Int iSrcStride5 = iSrcStride*5;
-  Int iSrcStride6 = iSrcStride*6;
-  Int iSrcStride7 = iSrcStride*7;
 
   Int  iTmp1, iTmp2;
@@ -993,5 +556,5 @@
             + (   piSrcTmp[iSrcStride4]           << 4 );
       
-      piDst[x * iDstStep] = Clip( ((iSum +  32) >>  6) + piSrcTmp[iSrcStride3] );
+      piDst[x * iDstStep] = ClipY( ((iSum +  32) >>  6) + piSrcTmp[iSrcStride3] );
       piSrcTmp += iSrcStep;
     }
@@ -1043,4 +606,6 @@
 __inline Void TRenInterpFilter::xCTI_FilterQuarter1Ver (Pel* piSrc, Int iSrcStride, Int iSrcStep, Int iWidth, Int iHeight, Int iDstStride, Int iDstStep, Pel*& rpiDst)
 {
+  assert( g_bitDepthC == g_bitDepthY);  // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Pel*  piDst = rpiDst;
   Int   iSum;
@@ -1070,5 +635,5 @@
             + (   piSrcTmp[iSrcStride3]           << 4 );
             
-      piDst[x * iDstStep] = Clip( ((iSum +  32) >>  6) +  piSrcTmp[iSrcStride4] );
+      piDst[x * iDstStep] = ClipY( ((iSum +  32) >>  6) +  piSrcTmp[iSrcStride4] );
       piSrcTmp += iSrcStep;
     }
@@ -1211,4 +776,5 @@
 __inline Void TRenInterpFilter::xCTI_Filter2DHorC(Int* piSrc, Int iSrcStride,  Int iWidth, Int iHeight, Int iDstStride,  Pel*& rpiDst, Int iMV)
 {
+  assert( g_bitDepthC == g_bitDepthY);  // ToDo: Update renderer to work with different luma/chroma bit depth 
   Pel*  piDst    = rpiDst;
   Int   iSum;
@@ -1225,5 +791,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_OCT0( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1241,5 +807,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_QUA0( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1257,5 +823,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_QUA1( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1273,5 +839,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_OCT1( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1289,5 +855,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_OCT2( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1305,5 +871,5 @@
         {
           iSum         = xCTI_Filter_VI04_C_OCT3( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1321,5 +887,5 @@
         {
           iSum      = xCTI_Filter_VIS04_C_HAL( piSrcTmp, 1 );
-          piDst   [x ] = Clip ((iSum +  2048) >>  12 );
+          piDst   [x ] = ClipC ((iSum +  2048) >>  12 );
           piSrcTmp++;
         }
@@ -1338,4 +904,6 @@
 __inline Void TRenInterpFilter::xCTI_Filter1DVerC (Pel* piSrc, Int iSrcStride, Int iWidth, Int iHeight, Int iDstStride,  Pel*& rpiDst, Int iMV)
 {
+  assert( g_bitDepthC == g_bitDepthY);  // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Pel*  piDst = rpiDst;
   Int   iSum;
@@ -1352,5 +920,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_OCT0( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1368,5 +936,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_QUA0( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1384,5 +952,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_QUA1( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1400,5 +968,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_OCT1( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1416,5 +984,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_OCT2( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1432,5 +1000,5 @@
         {
           iSum      = xCTI_Filter_VP04_C_OCT3( piSrcTmp,  iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1448,5 +1016,5 @@
         {
           iSum      = xCTI_Filter_VPS04_C_HAL( piSrcTmp, iSrcStride );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1478,5 +1046,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_OCT0( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1494,5 +1062,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_QUA0( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1510,5 +1078,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_QUA1( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1526,5 +1094,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_OCT1( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1542,5 +1110,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_OCT2( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1558,5 +1126,5 @@
         {
           iSum         = xCTI_Filter_VP04_C_OCT3( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
@@ -1574,5 +1142,5 @@
         {
           iSum         = xCTI_Filter_VPS04_C_HAL( piSrcTmp,  1 );
-          piDst[x ] = Clip ((iSum +  32) >>  6 );
+          piDst[x ] = ClipC ((iSum +  32) >>  6 );
           piSrcTmp++;
         }
